import java.io.Serializable;

/**
 * Klassen Brikke implementerer interfacen (kontrakten) IBrikke.
 * Representerer en brikke til spillet Fire-P-Rad
 * @author Trond Hellem B
 */
public class Brikke implements IBrikke,Serializable{

  private int rekke,kolonne; //rekken og kolonnen brikken er plassert i
  private ISpiller spiller; //referanse til spilleren som la brikken

  /**
   * Konstruktr. Initialiserer et Brikke-objekt
   * @param rekkeNr Rekkenummeret brikken havnet i
   * @param kolonneNr Kolonnen brikken ble sluppet ned i
   * @param hvilkenSpiller Hvilken spiller som gjorde trekket
   */
  public Brikke(int rekkeNr, int kolonneNr, ISpiller hvilkenSpiller){
    rekke=rekkeNr;
    kolonne=kolonneNr;
    spiller=hvilkenSpiller;
  }

  /**
   * Metode for i hente hvilket rekkenummer brikken er plassert i
   * @return int Rekkenummeret til brikken
   */
  public int hentRekke(){
    return rekke;
  }

  /**
   * Metode for i hente hvilket kolonnenummer brikken er plassert i
   * @return int Kolonnenummeret til brikken
   */
  public int hentKolonne(){
    return kolonne;
  }

  /**
   * Metode for i hente hvilken spiller som la denne brikken p
   * spillebrettet
   * @return ISpiller Spilleren som gjorde trekket
   */
  public ISpiller hentSpiller(){
    return spiller;
  }
}
