import java.awt.Color;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;

/**
 * Klasse for  vise et dialogvindu for et nytt Fire-P-Rad spill
 * @author Trond Hellem B
 */
public class GUINyttSpill extends JDialog implements ActionListener{

  JButton ok,avbryt; //knapper for valg

  //Tekstfelt for  skrive inn antall rekker og kolonner
  JTextField rekker,kolonner;

  //Valg for hvilken spiller som skal begynne
  JRadioButton spiller1Starter,spiller2Starter;
  ButtonGroup hvemBegynner;

  //referanse til hovedvinduet som laget dette objektet
  GUIHoved eier;

  /**
   * Konstruktr. Setter opp utseendet til dialogvinduet.
   * @param eier Referanse til hovedvinduet som oppretter dette
   * dialogvinduet
   */
  GUINyttSpill(GUIHoved eier){
    super(eier,"Nytt spill");
    this.eier=eier;
    Container content=getContentPane();

    JPanel innhold=new JPanel(new GridLayout(9,1));
    innhold.setBackground(Color.white);

    //Overskrifter
    JLabel overskrift=new JLabel("Brett Strrelse", JLabel.CENTER);
    innhold.add(overskrift);
    JPanel toTekst=new JPanel(new GridLayout(1,2));
    toTekst.add(new JLabel("Rekker", JLabel.CENTER));
    toTekst.add(new JLabel("Kolonner", JLabel.CENTER));
    toTekst.setBackground(Color.white);

    //Tekstfelt for input (antall rekker og kolonner)
    innhold.add(toTekst);
    JPanel toTekstFelt=new JPanel(new FlowLayout());
    rekker=new JTextField("7  ");
    kolonner=new JTextField("7  ");
    toTekstFelt.add(rekker);
    toTekstFelt.add(kolonner);
    toTekstFelt.setBackground(Color.white);
    innhold.add(toTekstFelt);

    //Ny overskrift
    JLabel overskrift2=new JLabel("Hvilken spiller skal begynne?", JLabel.CENTER);
    innhold.add(overskrift2);

    //Bruker en buttongroup slik at bare en spiller kan velges
    hvemBegynner=new ButtonGroup();
    spiller1Starter=new JRadioButton("Spiller 1",true);
    spiller2Starter=new JRadioButton("Spiller 2",false);
    spiller1Starter.setBackground(Color.white);
    spiller2Starter.setBackground(Color.white);
    hvemBegynner.add(spiller1Starter);
    hvemBegynner.add(spiller2Starter);
    JPanel spillerValg=new JPanel(new FlowLayout());
    spillerValg.add(spiller1Starter);
    spillerValg.add(spiller2Starter);
    spillerValg.setBackground(Color.white);
    innhold.add(spillerValg);

    //Knapper for  velge "OK" eller for  avbryte
    JPanel knapper=new JPanel(new FlowLayout());
    ok=new JButton("OK");
    avbryt=new JButton("Avbryt");
    ok.addActionListener(this);
    avbryt.addActionListener(this);
    knapper.add(ok);
    knapper.add(avbryt);
    knapper.setBackground(Color.white);
    innhold.add(knapper);

    content.add(innhold);
    pack();
    setVisible(true);
  }

  /**
   * Metode for  fange opp om noen knapper er blitt klikket p
   * @param e Hendelse som har skjedd
   */
  public void actionPerformed(ActionEvent e){
    if(e.getSource()==avbryt){
      //lukk vinduet dersom avbryt er valgt
      setVisible(false);
      dispose();
    }
    else if(e.getSource()==ok){
      //Dersom ok prver vi  lese inn verdier og sjekker dem
      int antallRekker=0,antallKolonner=0,hvilkenSpillerBegynner=1;
      try{
        //prver  lese inn antall rekker og kolonner
        antallRekker=Integer.parseInt(rekker.getText().trim());
        antallKolonner=Integer.parseInt(kolonner.getText().trim());
      }
      catch(Exception feil){
        //gi en feilmelding dersom det mislykkes
        JOptionPane.showMessageDialog(this,new JLabel("Feil i tallformat. " +
                                                       feil));
        return;
      }
      if(antallRekker<4){
        //feilmelding dersom frre enn 4 rekker
        JOptionPane.showMessageDialog(this,
                  new JLabel("Det m vre minst 4 rekker p spillebrettet."));
        return;
      }
      if(antallKolonner<4){
        //feilmelding dersom mindre enn 4 kolonner
        JOptionPane.showMessageDialog(this,
                new JLabel("Det m vre minst 4 kolonner p spillebrettet."));
        return;
      }
      if(spiller1Starter.isSelected())
        hvilkenSpillerBegynner=1;
      else
        hvilkenSpillerBegynner=2;

      //oppretter et nytt spill i hovedvinduet
      eier.opprettNyttSpill(antallRekker, antallKolonner,
                            hvilkenSpillerBegynner);
      setVisible(false);
      dispose();
    }
  }
}
