import java.awt.Color;
import java.awt.GridLayout;

import javax.swing.JLabel;
import javax.swing.JPanel;

/**
 * Klasse for  tegne et spillebrett for Fire-P-Rad
 * Klassen er en representasjon av spillebrettet som kan
 * vises som en grafisk komponent.
 * @author Trond Hellem B
 */

public class GUISpilleBrett extends JPanel{

  JLabel [][]felt;//Tabell som refererer til alle feltene som skal farges
  int rekker, kolonner;//antall rekker og kolonner p spillebrettet

  /**
   * Konstruktr. Oppretter et grafisk spillebrett med det spesifiserte
   * antallet rekker og kolonner.
   * @param rekker Antall rekker spillebrettet skal ha
   * @param kolonner Antall kolonner spillebrettet skal ha
   */
  GUISpilleBrett(int rekker, int kolonner){
    //Velger en GridLayout for  f et rutenett
    setLayout(new GridLayout(rekker+1,kolonner));

    //Setter overskrift kolonnenr. over hver kolonne
    for(int i=0;i<kolonner;i++)
      add(new JLabel(""+i, JLabel.CENTER));

    //For  farge alle feltene m vi ha en referanse til hver av dem
    felt=new JLabel[rekker][kolonner];

    //Initialiserer de fargbare feltene
    for(int i=0;i<rekker;i++)
      for(int j=0;j<kolonner;j++){
        felt[i][j]=new JLabel("");
        //M setter Opaque for at bakgrunnsfarge skal vises
        felt[i][j].setOpaque(true);

        //Legg feltet til spillebrettet
        add(felt[i][j]);
      }
    //Setter verdiene til variablene rekker og kolonner (i dette objektet)
    this.rekker=rekker;
    this.kolonner=kolonner;
  }

  /**
   * Metode for  fargelegge en brikke p brettet
   * @param rekke Rekken til brikken som skal farges
   * @param kolonne Kolonnen til brikken som skal farges
   * @param farge Fargen brikken skal ha
   */
  public void tegnEnBrikke(int rekke, int kolonne, Color farge){
    /*Farger en brikke p brettet med den spesifiserte fargen
     Tabellen felt refererer til spillebrettet opp-ned, derfor m vi
     telle rekker fra siste rekke som frste rekke*/
    felt[rekker-1-rekke][kolonne].setBackground(farge);
  }
}
