/**
 * Kontrakt for implementasjon av spillet Fire P Rad
 */
interface ISpill{
  /**
   * Gjr et trekk i den spesifikke kolonnen for den spesifiserte spilleren
   * @return int Rekkenummeret som trekket ble gjort i, ellers verdi < 0
   */
  int gjrTrekk(int kolonne, int spillerNummer);

  /**
   * @return ISpiller Spilleren med det spesifiserte nummeret
   */
  ISpiller hentSpiller(int spillerNummer);

  /**
   * @return ISpiller Spilleren som gjorde det siste trekket
   */
  ISpiller hentNvrendeSpiller();

  /**
   * @return ISpiller Spilleren som vant spillet, dersom spillet er ferdig,
   * ellers null
   */
  ISpiller hentVinner();

  /**
   * @return ISpilleBrett Spillebrettet som spillet spilles p
   */
  ISpilleBrett hentSpilleBrett();

  /**
   * @return boolean True dersom spillet er ferdig, ellers false
   */
  boolean spillErFerdig();
}
