/** 
 * Kontrakt for implementasjon av et Fire-P-Rad spillebrett 
 */ 
interface ISpilleBrett{ 
  
  /** 
   * @return IBrikke[][] Spillebrettet som en IBrikke array 
   */ 
  IBrikke [][] hentSpilleBrett(); 
  
  /** 
   * @return boolean True dersom den spesifiserte kolonnen ikke er full, 
   * ellers false (kan ikke gjre et trekk i denne kolonnen) 
   */ 
  boolean gyldigKolonneNummer(int kolonne); 
  
  /** 
   * Setter inn en brikke p brettet for den spesifiserte spillere og 
   * kolonne. Fargen p brikken bestemmes av spillerens farge. 
   * @return IBrikke Brikken som ble lagt til brettet. 
   */ 
  IBrikke leggTilBrikke(int kolonne, ISpiller spiller); 
  
  /** 
   * @return int Antall kolonner p spillebrettet 
   */ 
  int hentAntallKolonner(); 
  
  /** 
   * @return int Antall rekker p spillebrettet 
   */ 
  int hentAntallRekker(); 
} 
