import java.awt.Color;
import java.io.Serializable;

/**
 * Klassen Spiller implementerer interfacen (kontrakten) ISpiller.
 * Representerer en spiller av spillet Fire-P-Rad
 * @author Trond Hellem B
 */

public class Spiller implements ISpiller,Serializable{

  private int nummer;//Spillerens nummer

  /**
   * Konstruktr. Initialiserer spiller objektet
   * @param spillerNummer Spillerens nummer
   */
  Spiller (int spillerNummer) {
    nummer=spillerNummer;
  }

  /**
   * @return int Nummeret til spilleren
   */
  public int hentSpillerNummer () {
    return nummer;
  }

  /**
   * @return Color Spillerens farge (Color.red eller Color.blue)
   */
  public Color hentSpillerFarge () {
    if(nummer==1)
      return Color.red;
    else
      return Color.blue;
  }
}
